#include <time.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mgl_glut.h"
#include "mgl_zb.h"
#include "mgl_eps.h"
#include "mgl_c.h"
#include "mgl_eval.h"
//-----------------------------------------------------------------------------
mglData s;
//-----------------------------------------------------------------------------
int sample_ad(mglGraph *gr, const void *)	// arrow styles
{
	float a=0.1,b=0.4,c=0.5;
	gr->Line(mglPoint(a,1),mglPoint(b,1),"k-A");		gr->Puts(mglPoint(c,1),"Style 'A' or 'A\\_'","rL");
	gr->Line(mglPoint(a,0.8),mglPoint(b,0.8),"k-V");	gr->Puts(mglPoint(c,0.8),"Style 'V' or 'V\\_'","rL");
	gr->Line(mglPoint(a,0.6),mglPoint(b,0.6),"k-K");	gr->Puts(mglPoint(c,0.6),"Style 'K' or 'K\\_'","rL");
	gr->Line(mglPoint(a,0.4),mglPoint(b,0.4),"k-I");	gr->Puts(mglPoint(c,0.4),"Style 'I' or 'I\\_'","rL");
	gr->Line(mglPoint(a,0.2),mglPoint(b,0.2),"k-D");	gr->Puts(mglPoint(c,0.2),"Style 'D' or 'D\\_'","rL");
	gr->Line(mglPoint(a,0),mglPoint(b,0),"k-S");		gr->Puts(mglPoint(c,0),"Style 'S' or 'S\\_'","rL");
	gr->Line(mglPoint(a,-0.2),mglPoint(b,-0.2),"k-O");	gr->Puts(mglPoint(c,-0.2),"Style 'O' or 'O\\_'","rL");
	gr->Line(mglPoint(a,-0.4),mglPoint(b,-0.4),"k-T");	gr->Puts(mglPoint(c,-0.4),"Style 'T' or 'T\\_'","rL");
	gr->Line(mglPoint(a,-0.6),mglPoint(b,-0.6),"k-_");	gr->Puts(mglPoint(c,-0.6),"Style '\\_' or none","rL");
	gr->Line(mglPoint(a,-0.8),mglPoint(b,-0.8),"k-AS");	gr->Puts(mglPoint(c,-0.8),"Style 'AS'","rL");
	gr->Line(mglPoint(a,-1),mglPoint(b,-1),"k-_A");		gr->Puts(mglPoint(c,-1),"Style '\\_A'","rL");

	a=-1;	b=-0.7;	c=-0.6;
	gr->Line(mglPoint(a,1),mglPoint(b,1),"kAA");		gr->Puts(mglPoint(c,1),"Style 'AA'","rL");
	gr->Line(mglPoint(a,0.8),mglPoint(b,0.8),"kVV");	gr->Puts(mglPoint(c,0.8),"Style 'VV'","rL");
	gr->Line(mglPoint(a,0.6),mglPoint(b,0.6),"kKK");	gr->Puts(mglPoint(c,0.6),"Style 'KK'","rL");
	gr->Line(mglPoint(a,0.4),mglPoint(b,0.4),"kII");	gr->Puts(mglPoint(c,0.4),"Style 'II'","rL");
	gr->Line(mglPoint(a,0.2),mglPoint(b,0.2),"kDD");	gr->Puts(mglPoint(c,0.2),"Style 'DD'","rL");
	gr->Line(mglPoint(a,0),mglPoint(b,0),"kSS");		gr->Puts(mglPoint(c,0),"Style 'SS'","rL");
	gr->Line(mglPoint(a,-0.2),mglPoint(b,-0.2),"kOO");	gr->Puts(mglPoint(c,-0.2),"Style 'OO'","rL");
	gr->Line(mglPoint(a,-0.4),mglPoint(b,-0.4),"kTT");	gr->Puts(mglPoint(c,-0.4),"Style 'TT'","rL");
	gr->Line(mglPoint(a,-0.6),mglPoint(b,-0.6),"k-__");	gr->Puts(mglPoint(c,-0.6),"Style '\\_\\_'","rL");
	gr->Line(mglPoint(a,-0.8),mglPoint(b,-0.8),"k-VA");	gr->Puts(mglPoint(c,-0.8),"Style 'VA'","rL");
	gr->Line(mglPoint(a,-1),mglPoint(b,-1),"k-AV");		gr->Puts(mglPoint(c,-1),"Style 'AV'","rL");

	return 0;
}
//-----------------------------------------------------------------------------
int sample_ac(mglGraph *gr, const void *)	// error boxes
{
	mglData  x(10), y(10), ex(10), ey(10), y0(50);
	x.Modify("2*x-1 + 0.2*rnd-0.1");
	y.Modify("(2*x-1)^2 + 0.2*rnd-0.1");
	y0.Modify("(2*x-1)^2");
	ex.Modify("0.2");
	ey.Modify("0.1");

	gr->Clf();
	gr->SubPlot(2,2,0);
	gr->Error(y,ey,"ko");
	gr->Plot(y0,"r");
	gr->Axis();
	gr->Text(mglPoint(0,1.2,0),"Random {\\i y}");
	gr->SubPlot(2,2,1);
	gr->Error(x,y,ex,"ko");
	gr->Plot(y0,"r");
	gr->Axis();
	gr->Text(mglPoint(0,1.2,0),"Random {\\i x, y}");
	gr->SubPlot(2,2,2);
	gr->Error(x,y,ey,ey,"ko");
	gr->Plot(y0,"r");
	gr->Axis();
	gr->Text(mglPoint(0,1.2,0),"Random {\\i x, y} and 2d boxes");
	gr->SubPlot(2,2,3);
	gr->Text(mglPoint(0,1.2,0),"Random point in 3d space");
	gr->Rotate(40,60);
	for(int i=0;i<10;i++)
		gr->Error(mglPoint(mgl_rnd()-0.5,mgl_rnd()-0.5,mgl_rnd()-0.5),
			mglPoint(0.1,0.1,0.1),"bo");
	gr->Axis();
	return 0;
}
//-----------------------------------------------------------------------------
int sample_ab(mglGraph *gr, const void *)	// Gaussian beam
{
	gr->Alpha(true);	gr->Light(true);	gr->Light(0,mglPoint(0,0,1));
	mglData a(30,30,30),b(30,30,30);
	a.Modify("exp(-16*((z-0.5)^2+(y-0.5)^2)/(1+4*x^2))");
	b.Modify("16*((z-0.5)^2+(y-0.5)^2)*(x)/(1+4*x^2)");
	gr->CAxis(0,1);

	gr->SubPlot(2,2,0);	gr->Rotate(40,60);
	gr->Surf3(a,"wgk");	gr->Box();
	gr->SubPlot(2,2,1);	gr->Rotate(40,60);
	gr->DensA(a);		gr->Box();	gr->Axis();
	gr->SubPlot(2,2,2);	gr->Rotate(40,60);
	gr->CloudQ(a);		gr->Box();
	gr->SubPlot(2,2,3);	gr->Rotate(40,60);
	gr->Surf3A(b,a,"q");gr->Box();
	return 0;
}
//-----------------------------------------------------------------------------
int sample_aa(mglGraph *gr, const void *)	// flag #
{
	gr->Alpha(true);	gr->Light(true);	gr->Light(0,mglPoint(0,0,1));
	mglData a(30,20);
	a.Modify("0.6*sin(2*pi*x)*sin(3*pi*y) + 0.4*cos(3*pi*(x*y))");

	gr->SubPlot(2,2,0);	gr->Rotate(40,60);
	gr->Surf(a,"BbcyrR#");		gr->Box();
	gr->SubPlot(2,2,1);	gr->Rotate(40,60);
	gr->Dens(a,"BbcyrR#");		gr->Box();
	gr->SubPlot(2,2,2);	gr->Rotate(40,60);
	gr->Cont(a,"BbcyrR#");		gr->Box();
	gr->SubPlot(2,2,3);	gr->Rotate(40,60);
	gr->Axial(a,"BbcyrR#");		gr->Box();
	return 0;
}
//-----------------------------------------------------------------------------
int sample_a9(mglGraph *gr, const void *)	// 2d plot
{
	gr->Light(true);	gr->Light(0,mglPoint(0,0,1));

	mglData a0(50,40);
	a0.Modify("0.6*sin(2*pi*x)*sin(3*pi*y) + 0.4*cos(3*pi*(x*y))");
	gr->SubPlot(2,2,0);	gr->Rotate(60,40);
	gr->Surf(a0);		gr->Box();

	mglData x(50,40),y(50,40),z(50,40);
	x.Modify("0.8*sin(2*pi*x)*sin(pi*y)");
	y.Modify("0.8*cos(2*pi*x)*sin(pi*y)");
	z.Modify("0.8*cos(pi*y)");
	gr->SubPlot(2,2,1);	gr->Rotate(60,40);
	gr->Surf(x,y,z,"BbwrR");		gr->Box();

	mglData a1(50,40,3);
	a1.Modify("0.6*sin(2*pi*x)*sin(3*pi*y) + 0.4*cos(3*pi*(x*y))");
	a1.Modify("0.6*cos(2*pi*x)*cos(3*pi*y) + 0.4*sin(3*pi*(x*y))",1);
	a1.Modify("0.6*cos(2*pi*x)*cos(3*pi*y) + 0.4*cos(3*pi*(x*y))",2);
	gr->SubPlot(2,2,2);	gr->Rotate(60,40);
	gr->Alpha(true);
	gr->Surf(a1);		gr->Box();

	gr->SubPlot(2,2,3);	gr->Rotate(60,40);
	gr->Dens(a1);		gr->Box();

	return 0;
}
//-----------------------------------------------------------------------------
int sample_a8(mglGraph *gr, const void *)	// 1d plot
{
	mglData y0(50);		y0.Modify("sin(pi*(2*x-1))");
	gr->SubPlot(2,2,0);
	gr->Plot(y0);		gr->Box();

	gr->SubPlot(2,2,1);
	mglData y1(50,2);
	y1.Modify("sin(pi*2*x-pi)");	y1.Modify("cos(pi*2*x-pi)/2",1);
	gr->Plot(y1);		gr->Box();

	mglData x(50);		x.Modify("cos(pi*2*x-pi)");
	gr->Plot(x,y0,"Y+");

	gr->Plot2(y1,"q|");

	gr->SubPlot(2,2,2);	gr->Rotate(60,40);
	mglData z(50);		z.Modify("2*x-1");
	gr->Plot(x,y0,z);		gr->Box();

	mglData y2(10,3);	y2.Modify("cos(pi*(2*x-1+y))");
	y2.Modify("2*x-1",2);
	gr->Plot3(y2,"bo ");

	gr->SubPlot(2,2,3);	gr->Rotate(60,40);
	gr->Bars(x,y0,z,"ri");		gr->Box();
	return 0;
}
//-----------------------------------------------------------------------------
int sample_a7(mglGraph *gr, const void *)	// smoothing
{
	mglData y0(30),y1,y2,y3;
	y0.Modify("0.4*sin(2*pi*x) + 0.3*cos(3*pi*x) - 0.4*sin(4*pi*x)+0.2*rnd");

	y1=y0;	y1.Smooth(SMOOTH_LINE_3);
	y2=y0;	y2.Smooth(SMOOTH_LINE_5);
	y3=y0;	y3.Smooth(SMOOTH_QUAD_5);

	gr->Plot(y0,"k");	gr->AddLegend("NONE","k");
	gr->Plot(y1,"r");	gr->AddLegend("LINE_3","r");
	gr->Plot(y2,"g");	gr->AddLegend("LINE_5","g");
	gr->Plot(y3,"b");	gr->AddLegend("QUAD_5","b");
	gr->Legend();		gr->Box();
	gr->ClearLegend();	// clear legend strings
	return 0;
}
//-----------------------------------------------------------------------------
int sample_a6(mglGraph *gr, const void *)	// differentiate
{
	mglData a(30,40);	a.Modify("x*y");
	gr->Axis(mglPoint(0,0,0),mglPoint(1,1,1));
	gr->SubPlot(2,2,0);	gr->Rotate(60,40);
	gr->Surf(a);		gr->Box();
	gr->Puts(mglPoint(0.7,1,1.2),"a(x,y)");
	gr->SubPlot(2,2,1);	gr->Rotate(60,40);
	a.Diff("x");		gr->Surf(a);	gr->Box();
	gr->Puts(mglPoint(0.7,1,1.2),"da/dx");
	gr->SubPlot(2,2,2);	gr->Rotate(60,40);
	a.Integral("xy");	gr->Surf(a);	gr->Box();
	gr->Puts(mglPoint(0.7,1,1.2),"\\int da/dx dxdy");
	gr->SubPlot(2,2,3);	gr->Rotate(60,40);
	a.Diff2("y");	gr->Surf(a);	gr->Box();
	gr->Puts(mglPoint(0.7,1,1.2),"\\int {d^2}a/dxdy dx");
	return 0;
}
//-----------------------------------------------------------------------------
int sample_a5(mglGraph *gr, const void *)	// pen styles
{
	gr->Line(mglPoint(0,1,0),mglPoint(0.3,1,0),"k-");		gr->Puts(mglPoint(0.4,1),"Solid '-'","rL");
	gr->Line(mglPoint(0,0.7,0),mglPoint(0.3,0.7,0),"k|");	gr->Puts(mglPoint(0.4,0.7),"Dash '|'","rL");
	gr->Line(mglPoint(0,0.4,0),mglPoint(0.3,0.4,0),"k;");	gr->Puts(mglPoint(0.4,0.4),"Small dash ';'","rL");
	gr->Line(mglPoint(0,0.1,0),mglPoint(0.3,0.1,0),"kj");	gr->Puts(mglPoint(0.4,0.1),"Dash-dot 'j'","rL");
	gr->Line(mglPoint(0,-0.2,0),mglPoint(0.3,-0.2,0),"ki");	gr->Puts(mglPoint(0.4,-0.2),"Small dash-dot 'i'","rL");
	gr->Line(mglPoint(0,-0.5,0),mglPoint(0.3,-0.5,0),"k:");	gr->Puts(mglPoint(0.4,-0.5),"Dots ':'","rL");
	gr->Line(mglPoint(0,-0.8,0),mglPoint(0.3,-0.8,0),"k ");	gr->Puts(mglPoint(0.4,-0.8),"None ' '","rL");

	gr->Mark(mglPoint(-1,1.2,0),'.');	gr->Puts(mglPoint(-0.7,1.2),"'.'","rL");
	gr->Mark(mglPoint(-1,0.9,0),'+');	gr->Puts(mglPoint(-0.7,0.9),"'+'","rL");
	gr->Mark(mglPoint(-1,0.6,0),'x');	gr->Puts(mglPoint(-0.7,0.6),"'x'","rL");
	gr->Mark(mglPoint(-1,0.3,0),'*');	gr->Puts(mglPoint(-0.7,0.3),"'*'","rL");
	gr->Mark(mglPoint(-1,0.0,0),'s');	gr->Puts(mglPoint(-0.7,0.0),"'s'","rL");
	gr->Mark(mglPoint(-1,-0.3,0),'d');	gr->Puts(mglPoint(-0.7,-0.3),"'d'","rL");
	gr->Mark(mglPoint(-1,-0.6,0),'o');	gr->Puts(mglPoint(-0.7,-0.6),"'o'","rL");
	gr->Mark(mglPoint(-1,-0.9,0),'^');	gr->Puts(mglPoint(-0.7,-0.9),"'\\^'","rL");
	gr->Mark(mglPoint(-1,-1.2,0),'v');	gr->Puts(mglPoint(-0.7,-1.2),"'v'","rL");
	return 0;
}
//-----------------------------------------------------------------------------
int sample_a4(mglGraph *gr, const void *)	// font features
{
	gr->Puts(mglPoint(0,1),"Text can be in english   ");
	gr->Puts(mglPoint(0,0.6),"It can be {\\s script} and {\\g gothic}");
	gr->Puts(mglPoint(0,0.2),"One can change style in string: {\\b bold}, {\\i italic, \\b both}");
	gr->Puts(mglPoint(0,-0.2),"Easy to {\\a overline} or {\\u underline}");
	gr->Puts(mglPoint(0,-0.6),"Easy to change indexes ^up _down @center");
	gr->Puts(mglPoint(0,-1),"It parse TeX: \\int \\alpha \\cdot "
		"\\sqrt{\\a sin(\\pi x)^2 + \\gamma_i} dx");
	return 0;
}
//-----------------------------------------------------------------------------
int sample_a3(mglGraph *gr, const void *)	// curvilinear coordinates
{
	mglData x(50),y(50),z(50);
	y.Fill(0.5,0.5);
	x.Fill(-1,1);           // create data arrays

	gr->Axis(mglPoint(-1,-1,-1),mglPoint(1,1,1),mglPoint(-1,1,-1));
	gr->dx = gr->dy = -6;	gr->dz = 0.5;  // set tick step to 0.5

	gr->SubPlot(2,2,0);
	gr->Rotate(60,40);
	gr->Plot(x,y,z,"r2");
	gr->Axis(); gr->Grid();
	gr->Puts(mglPoint(0,1.3,1),"Cartesian");

	gr->SubPlot(2,2,1);
	gr->Axis("y*sin(pi*x)","y*cos(pi*x)",0);
	gr->Rotate(60,40);
	gr->Plot(x,y,z,"r2");
	gr->Axis(); gr->Grid();
	gr->Puts(mglPoint(0,1.3,1),"Cylindrical");

	gr->SubPlot(2,2,2);
	gr->Rotate(60,40);
	gr->Axis("2*y*x","y*y - x*x",0);
	gr->Plot(x,y,z,"r2");
	gr->Axis(); gr->Grid();
	gr->Puts(mglPoint(0,1.3,1),"Parabolic");

	gr->SubPlot(2,2,3);
	gr->Rotate(60,40);
	gr->Axis("y*sin(pi*x)","y*cos(pi*x)","x+z");
	gr->Plot(x,y,z,"r2");
	gr->Axis(); gr->Grid();
	gr->Puts(mglPoint(0,1.3,1),"Spiral");
	gr->Axis(0,0,0);	// set to default Cartesian
	return 0;
}
//-----------------------------------------------------------------------------
int sample_a2(mglGraph *gr, const void *)	// axis and grid
{
	gr->SubPlot(2,2,0);
	gr->dx = gr->dy = 0.5;  // set tick step to 0.5
	gr->NSx = gr->NSy = 3;  // and draw 3 subticks
	gr->Box();              // should be after change dx,dy,dz
	gr->Axis("xy");
	gr->Grid();
	gr->Puts(mglPoint(0,1.3,1),"Axis and grid","rC");

	gr->dx = gr->dy = -6;   // restore back
	gr->NSx = gr->NSy = 0;
	gr->Axis(mglPoint(-1,-1,-1),mglPoint(1,1,1),mglPoint(0,0,0));

	gr->dx = gr->dy = gr->dz = -6;   // restore back
	gr->SubPlot(2,2,1);
	gr->Rotate(60,40);
	gr->Axis();
	gr->Label('x',"x");
	gr->Label('y',"y");
	gr->Label('z',"z");
	gr->Puts(mglPoint(0,0,1.5),"Axis and labels");

	gr->dx = gr->dy = gr->dz = 0.2;   // too low step of ticks
	gr->SubPlot(2,2,2);
	gr->Rotate(60,40);
	gr->Axis(mglPoint(-1,-1,-1),mglPoint(1,1,1),mglPoint(-1,-1,-1));
	gr->Axis();
	gr->Grid();
	gr->Puts(mglPoint(0,0,1.5),"Shift origin and add grid");
	gr->Puts(mglPoint(0,0,1.2),"(note, too many ticks)");

	gr->SubPlot(2,2,3);
	gr->Rotate(60,40);
	gr->dz = gr->dy = -5;   // decrease number of ticks
	gr->Axis("yz");
	gr->Label('y',"Y axis",0);
	gr->Label('z',"Z axis",0);
	gr->Puts(mglPoint(0,0,1.5),"Remove X axis, and","rC");
	gr->Puts(mglPoint(0,0,1.2),"decrease number of ticks");
	return 0;
}
//-----------------------------------------------------------------------------
int sample_a1(mglGraph *gr, const void *)	// transformation
{
	gr->SubPlot(2,2,0);     // just new axis without rotation and aspects
	gr->Box();
	gr->Puts(mglPoint(-1,1.1,1),"Just box","rL");
	gr->InPlot(0.2,0.5,0.7,1);
	gr->Box();
	gr->Puts(mglPoint(0,1.2,1),"InPlot example");
	gr->SubPlot(2,2,1);     // new axis with aspect and rotation
	gr->Rotate(60,40);
	gr->Aspect(1,1,1);
	gr->Box();
	gr->Puts(mglPoint(1,1,1.5),"Rotate only","rR");
	gr->SubPlot(2,2,2);     // aspect in other direction
	gr->Rotate(60,40);
	gr->Aspect(1,1,2);
	gr->Box();
	gr->Puts(mglPoint(0,0,2),"Aspect and Rotate");
	gr->SubPlot(2,2,3);     // rotation before aspect. INCORRECT !!!
	gr->Rotate(60,40);
	gr->Aspect(1,2,2);
	gr->Box();
	gr->Puts(mglPoint(0,0,1.5),"Aspect in other direction");
	return 0;
}
//-----------------------------------------------------------------------------
int full_test_png(mglGraph *gr, const void *)	// full test (in PNG)
{
	mglData pnts("hotdogs.pts");
	pnts.Norm(-1,1,true);
	mglData  a(50,40), b(50,40), c(60,50,40), d(60,50,40);
	mglData y(50,3), x(50), x2(50), y1(50), y2(50), f(50,3);
	mglData ex(10,10,10), ey(10,10,10), ez(10,10,10);
	ex.Modify("0.1*(x-0.5)/pow((x-0.5)^2+(y-0.5)^2+(z-0.35)^2,1.5)-0.1*(x-0.5)/pow((x-0.5)^2+(y-0.5)^2+(z-0.65)^2,1.5)");
	ey.Modify("0.1*(y-0.5)/pow((x-0.5)^2+(y-0.5)^2+(z-0.35)^2,1.5)-0.1*(y-0.5)/pow((x-0.5)^2+(y-0.5)^2+(z-0.65)^2,1.5)");
	ez.Modify("0.1*(z-0.35)/pow((x-0.5)^2+(y-0.5)^2+(z-0.35)^2,1.5)-0.1*(z-0.65)/pow((x-0.5)^2+(y-0.5)^2+(z-0.65)^2,1.5)");
	a.Modify("0.6*sin(2*pi*x)*sin(3*pi*y) + 0.4*cos(3*pi*(x*y))");
	b.Modify("0.6*cos(2*pi*x)*cos(3*pi*y) + 0.4*cos(3*pi*(x*y))");
	c.Modify("(-2*((2*x-1)^2 + (2*y-1)^2 + (2*z-1)^4 - (2*z-1)^2 - 0.1))");
//	d.Modify("2*exp(-2*((2*x-1)^2 + (2*y-1)^2))-1");
	d.Modify("1-2*tanh(4*(x+y-1)^2)");
	y.Modify("0.7*sin(2*pi*x) + 0.5*cos(3*pi*x) + 0.2*sin(pi*x)",0);
	y.Modify("sin(2*pi*x)",1);	y.Modify("cos(2*pi*x)",2);
	y1.Modify("0.5+0.3*cos(2*pi*x)");
	y2.Modify("0.3*sin(2*pi*x)");
	x.Fill(-1,1,'x');
	x2.Modify("0.05+0.03*cos(2*pi*x)");

	mglData  x0(10), y0(10), ex0(10), ey0(10),ch(7,2);
	x0.Modify("2*x-1 + 0.1*rnd-0.05");
	y0.Modify("0.7*sin(2*pi*x) + 0.5*cos(3*pi*x) + 0.2*sin(pi*x) + 0.2*rnd-0.1");
	ey0.Modify("0.2");	ex0.Modify("0.1");	ch.Modify("rnd+0.1");
	bool tr_png = false;	// write with transparent background

	gr->SubPlot(1,1,0);
	gr->Rotate(40,60);	gr->Alpha(false);
	gr->Clf();	gr->Box();	gr->Surf(a,"BbcyrR");	gr->WritePNG("surf.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Tile(a,"BbcyrR");	gr->WritePNG("tile.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Belt(a,"BbcyrR");	gr->WritePNG("belt.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Mesh(a,"BbcyrR");	gr->WritePNG("mesh.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Fall(a,"BbcyrR");	gr->WritePNG("fall.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->SurfC(a,b,"BbcyrR");gr->WritePNG("surfc.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Boxs(a,"BbcyrR");	gr->WritePNG("boxs.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Flow(ex,ey,ez,"bwr");	gr->WritePNG("flow3.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Vect(ex,ey,ez,"bwr");	gr->WritePNG("vect3.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->VectC(ex,ey,ez,"bwr");	gr->WritePNG("vectc3.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Torus(y1,y2,"pz");	gr->WritePNG("torus.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Crust(pnts);		gr->WritePNG("crust.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Dots(pnts);			gr->WritePNG("dots.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->ContF(a,"BbcyrR");	gr->WritePNG("contf.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Cont(a,"BbcyrR");	gr->WritePNG("cont.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->ContFA(c,"BbcyrR");	gr->WritePNG("contfa.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Tube(y,0.05);	gr->Tube(y1,x,y2,x2);	gr->WritePNG("tube.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Chart(ch,"#");	gr->WritePNG("chart.png",0,tr_png);
	gr->Axis("(y+1)/2*cos(pi*x)","(y+1)/2*sin(pi*x)",0);
	gr->Clf();	gr->Box();	gr->Chart(ch,"#");	gr->WritePNG("pie_chart.png",0,tr_png);	gr->Axis(0,0,0);

	gr->Alpha(true);
	gr->Clf();	gr->Box();	gr->Surf(a,"BbcyrR");	gr->WritePNG("surf_alpha.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Axial(a,"BbcyrRx");	gr->WritePNG("axial.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->SurfA(a,b,"BbcyrR");gr->WritePNG("surfa.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Map(a,b,"BbcyrR");	gr->WritePNG("map.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Surf3(c,"BbcyrR");	gr->WritePNG("surf3.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Surf3(c,"bgrd");	gr->WritePNG("surf3_rgbd_light.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Surf3A(c,d,"BbcyrR");gr->WritePNG("surf3a.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Surf3C(c,d,"BbcyrR");gr->WritePNG("surf3c.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->ContA(c,"BbcyrR");	gr->WritePNG("conta.png",0,tr_png);
	gr->Light(false);
	gr->Clf();	gr->Box();	gr->CloudQ(c,"wyrRk");	gr->WritePNG("cloudq.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->CloudP(c,"wyrRk");	gr->WritePNG("cloudp.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Axis();	gr->DensA(c,"BbcyrR");	gr->WritePNG("densa.png",0,tr_png);
	gr->Alpha(false);
	gr->Clf();	gr->Box();	gr->Surf3(c,"bgrd");gr->WritePNG("surf3_rgbd.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->DensX(c.Sum("x"),"BbcyrR",-1);	gr->DensY(c.Sum("y"),"BbcyrR",1);
	gr->DensZ(c.Sum("z"),"BbcyrR",-1);	gr->WritePNG("dens_xyz.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->ContX(c.Sum("x"),"BbcyrR",-1);	gr->ContY(c.Sum("y"),"BbcyrR",1);
	gr->ContZ(c.Sum("z"),"BbcyrR",-1);	gr->WritePNG("cont_xyz.png",0,tr_png);
	gr->SubPlot(1,1,0);	// 1D Plots
	gr->Clf();	gr->Box();	gr->Plot(y);	gr->WritePNG("plot.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Area(y);	gr->WritePNG("area.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Stem(y);	gr->WritePNG("stem.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Step(y);	gr->WritePNG("step.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Bars(y);	gr->WritePNG("bars.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Mark(y,y1,"bo");	gr->WritePNG("mark.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Plot(y.SubData(-1,0));	gr->Text(y,"This is very long string drawn along a curve",":k");	gr->WritePNG("text.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Plot(y.SubData(-1,0));	gr->Error(x0,y0,ex0,ey0,"ko");	gr->WritePNG("error.png",0,tr_png);

	gr->Clf();	gr->Box();	gr->Dens(a,"BbcyrR");	gr->Colorbar();	gr->WritePNG("dens.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Cont(a,"BbcyrRt");	gr->WritePNG("contt.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Vect(a,b,"BbcyrR");	gr->WritePNG("vect.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->VectC(a,b,"BbcyrR");gr->WritePNG("vectc.png",0,tr_png);
	gr->Clf();	gr->Box();	gr->Flow(a,b,"BbcyrR");	gr->WritePNG("flow.png",0,tr_png);

	f.Modify("sin(2*pi*x*x)",0);	f.Modify("sin(2*pi*x)",1);	f.Modify("sin(2*pi*sqrt(x))",2);
	gr->Axis(mglPoint(0,-1,0),mglPoint(1,1,1));	gr->Clf();	gr->Box();
	gr->Plot(f);	gr->Axis("xy");	gr->AddLegend("sin(\\pi {x^2})","b");
	gr->AddLegend("sin(\\pi x)","g*");	gr->AddLegend("sin(\\pi \\sqrt{\\a x})","r+");
	gr->Legend();	gr->WritePNG("legend.png",0,tr_png);
	gr->ClearLegend();	// clear legend strings
	return 0;
}
//-----------------------------------------------------------------------------
int full_test_eps(mglGraph *gr, const void *)	// full test (in EPS)
{
	mglData pnts("hotdogs.pts");
	pnts.Norm(-1,1,true);
	mglData  a(50,40), b(50,40), c(60,50,40), d(60,50,40);
	mglData y(50,3), x(50), x2(50), y1(50), y2(50), f(50,3);
	mglData ex(10,10,10), ey(10,10,10), ez(10,10,10);
	ex.Modify("0.1*(x-0.5)/pow((x-0.5)^2+(y-0.5)^2+(z-0.35)^2,1.5)-0.1*(x-0.5)/pow((x-0.5)^2+(y-0.5)^2+(z-0.65)^2,1.5)");
	ey.Modify("0.1*(y-0.5)/pow((x-0.5)^2+(y-0.5)^2+(z-0.35)^2,1.5)-0.1*(y-0.5)/pow((x-0.5)^2+(y-0.5)^2+(z-0.65)^2,1.5)");
	ez.Modify("0.1*(z-0.35)/pow((x-0.5)^2+(y-0.5)^2+(z-0.35)^2,1.5)-0.1*(z-0.65)/pow((x-0.5)^2+(y-0.5)^2+(z-0.65)^2,1.5)");
	a.Modify("0.6*sin(2*pi*x)*sin(3*pi*y) + 0.4*cos(3*pi*(x*y))");
	b.Modify("0.6*cos(2*pi*x)*cos(3*pi*y) + 0.4*cos(3*pi*(x*y))");
	c.Modify("(-2*((2*x-1)^2 + (2*y-1)^2 + (2*z-1)^4 - (2*z-1)^2 - 0.1))");
//	d.Modify("2*exp(-2*((2*x-1)^2 + (2*y-1)^2))-1");
	d.Modify("1-2*tanh(4*(x+y-1)^2)");
	y.Modify("0.7*sin(2*pi*x) + 0.5*cos(3*pi*x) + 0.2*sin(pi*x)",0);
	y.Modify("sin(2*pi*x)",1);	y.Modify("cos(2*pi*x)",2);
	y1.Modify("0.5+0.3*cos(2*pi*x)");
	y2.Modify("0.3*sin(2*pi*x)");
	x.Fill(-1,1,'x');
	x2.Modify("0.05+0.03*cos(2*pi*x)");

	gr->SubPlot(1,1,0);
	gr->Rotate(40,60);	gr->Alpha(false);
	gr->Clf();	gr->Box();	gr->Surf(a,"BbcyrR");	gr->WriteEPS("surf.eps");
	gr->Clf();	gr->Box();	gr->Tile(a,"BbcyrR");	gr->WriteEPS("tile.eps");
	gr->Clf();	gr->Box();	gr->Belt(a,"BbcyrR");	gr->WriteEPS("belt.eps");
	gr->Clf();	gr->Box();	gr->Mesh(a,"BbcyrR");	gr->WriteEPS("mesh.eps");
	gr->Clf();	gr->Box();	gr->Fall(a,"BbcyrR");	gr->WriteEPS("fall.eps");
	gr->Clf();	gr->Box();	gr->SurfC(a,b,"BbcyrR");gr->WriteEPS("surfc.eps");
	gr->Clf();	gr->Box();	gr->Boxs(a,"BbcyrR");	gr->WriteEPS("boxs.eps");
	gr->Clf();	gr->Box();	gr->Flow(ex,ey,ez,"bwr");	gr->WriteEPS("flow3.eps");
	gr->Clf();	gr->Box();	gr->Vect(ex,ey,ez,"bwr");	gr->WriteEPS("vect3.eps");
	gr->Clf();	gr->Box();	gr->VectC(ex,ey,ez,"bwr");	gr->WriteEPS("vectc3.eps");
	gr->Clf();	gr->Box();	gr->Torus(y1,y2,"r");	gr->WriteEPS("torus.eps");
	gr->Clf();	gr->Box();	gr->Crust(pnts);		gr->WriteEPS("crust.eps");
	gr->Clf();	gr->Box();	gr->Dots(pnts);			gr->WriteEPS("dots.eps");
	gr->Clf();	gr->Box();	gr->Cont(a,"BbcyrR");	gr->WriteEPS("cont.eps");
	gr->Clf();	gr->Box();	gr->ContF(a,"BbcyrR");	gr->WriteEPS("contf.eps");
	gr->Clf();	gr->Box();	gr->ContFA(c,"BbcyrR");	gr->WriteEPS("contf3.eps");
	gr->Clf();	gr->Box();	gr->Tube(y,0.05);	gr->Tube(y1,x,y2,x2);	gr->WriteEPS("tube.eps");

	gr->Alpha(true);
	gr->Clf();	gr->Box();	gr->Surf(a,"BbcyrR");	gr->WriteEPS("alpha.eps");
	gr->Clf();	gr->Box();	gr->Axial(a,"BbcyrRx");	gr->WriteEPS("axial.eps");
	gr->Clf();	gr->Box();	gr->SurfA(a,b,"BbcyrR");gr->WriteEPS("surfa.eps");
	gr->Clf();	gr->Box();	gr->Map(a,b,"BbcyrR");	gr->WriteEPS("map.eps");
	gr->Clf();	gr->Box();	gr->Surf3(c,"BbcyrR");	gr->WriteEPS("surf3.eps");
	gr->Clf();	gr->Box();	gr->Surf3(c,"bgrd");	gr->WriteEPS("surf3_rgbd_light.eps");
	gr->Clf();	gr->Box();	gr->Surf3A(c,d,"BbcyrR");gr->WriteEPS("surf3a.eps");
	gr->Clf();	gr->Box();	gr->Surf3C(c,d,"BbcyrR");gr->WriteEPS("surf3c.eps");
	gr->Clf();	gr->Box();	gr->ContA(c,"BbcyrR");	gr->WriteEPS("conta.eps");
	gr->Light(false);
//	gr->Clf();	gr->Box();	gr->CloudQ(c,"wyrRk");	gr->WriteEPS("cloudq.eps");
//	gr->Clf();	gr->Box();	gr->CloudP(c,"wyrRk");	gr->WriteEPS("cloudp.eps");
	gr->Clf();	gr->Box();	gr->Axis();	gr->DensA(c,"BbcyrR");	gr->WriteEPS("densa.eps");
	gr->Alpha(false);
	gr->Clf();	gr->Box();	gr->Surf3(c,"bgrd");gr->WriteEPS("surf3_rgbd.eps");
	gr->Clf();	gr->Box();	gr->DensX(c.Sum("x"),"BbcyrR",-1);	gr->DensY(c.Sum("y"),"BbcyrR",1);
	gr->DensZ(c.Sum("z"),"BbcyrR",-1);	gr->WriteEPS("dens_xyz.eps");
	gr->Clf();	gr->Box();	gr->ContX(c.Sum("x"),"BbcyrR",-1);	gr->ContY(c.Sum("y"),"BbcyrR",1);
	gr->ContZ(c.Sum("z"),"BbcyrR",-1);	gr->WriteEPS("cont_xyz.eps");
	gr->SubPlot(1,1,0);	// 1D Plots
	gr->Clf();	gr->Box();	gr->Plot(y);	gr->WriteEPS("plot.eps");
	gr->Clf();	gr->Box();	gr->Area(y);	gr->WriteEPS("area.eps");
	gr->Clf();	gr->Box();	gr->Stem(y);	gr->WriteEPS("stem.eps");
	gr->Clf();	gr->Box();	gr->Step(y);	gr->WriteEPS("step.eps");
	gr->Clf();	gr->Box();	gr->Bars(y);	gr->WriteEPS("bars.eps");
	gr->Clf();	gr->Box();	gr->Mark(y,y1,"bo");	gr->WriteEPS("mark.eps");
	gr->Clf();	gr->Box();	gr->Plot(y.SubData(-1,0));	gr->Text(y,"This is very long string drawn along a curve",":k");	gr->WriteEPS("text.eps");

	gr->Clf();	gr->Box();	gr->Dens(a,"BbcyrR");	gr->Colorbar();	gr->WriteEPS("dens.eps");
	gr->Clf();	gr->Box();	gr->Cont(a,"BbcyrRt");	gr->WriteEPS("contt.eps");
	gr->Clf();	gr->Box();	gr->Vect(a,b,"BbcyrR");	gr->WriteEPS("vect.eps");
	gr->Clf();	gr->Box();	gr->VectC(a,b,"BbcyrR");gr->WriteEPS("vectc.eps");
	gr->Clf();	gr->Box();	gr->Flow(a,b,"BbcyrR");	gr->WriteEPS("flow.eps");

	f.Modify("sin(2*pi*x*x)",0);	f.Modify("sin(2*pi*x)",1);	f.Modify("sin(2*pi*sqrt(x))",2);
	gr->Axis(mglPoint(0,-1,0),mglPoint(1,1,1));	gr->Clf();	gr->Box();
	gr->Plot(f);	gr->Axis("xy");	gr->AddLegend("sin(\\pi {x^2})","b");
	gr->AddLegend("sin(\\pi x)","g*");	gr->AddLegend("sin(\\pi \\sqrt{\\a x})","r+");
	gr->Legend();	gr->WriteEPS("legend.eps");
	gr->ClearLegend();	// clear legend strings
	return 0;
}
//-----------------------------------------------------------------------------
int full_test_svg(mglGraph *gr, const void *)	// full test (in EPS)
{
	mglData pnts("hotdogs.pts");
	pnts.Norm(-1,1,true);
	mglData  a(50,40), b(50,40), c(60,50,40), d(60,50,40);
	mglData y(50,3), x(50), x2(50), y1(50), y2(50), f(50,3);
	mglData ex(10,10,10), ey(10,10,10), ez(10,10,10);
	ex.Modify("0.1*(x-0.5)/pow((x-0.5)^2+(y-0.5)^2+(z-0.35)^2,1.5)-0.1*(x-0.5)/pow((x-0.5)^2+(y-0.5)^2+(z-0.65)^2,1.5)");
	ey.Modify("0.1*(y-0.5)/pow((x-0.5)^2+(y-0.5)^2+(z-0.35)^2,1.5)-0.1*(y-0.5)/pow((x-0.5)^2+(y-0.5)^2+(z-0.65)^2,1.5)");
	ez.Modify("0.1*(z-0.35)/pow((x-0.5)^2+(y-0.5)^2+(z-0.35)^2,1.5)-0.1*(z-0.65)/pow((x-0.5)^2+(y-0.5)^2+(z-0.65)^2,1.5)");
	a.Modify("0.6*sin(2*pi*x)*sin(3*pi*y) + 0.4*cos(3*pi*(x*y))");
	b.Modify("0.6*cos(2*pi*x)*cos(3*pi*y) + 0.4*cos(3*pi*(x*y))");
	c.Modify("(-2*((2*x-1)^2 + (2*y-1)^2 + (2*z-1)^4 - (2*z-1)^2 - 0.1))");
//	d.Modify("2*exp(-2*((2*x-1)^2 + (2*y-1)^2))-1");
	d.Modify("1-2*tanh(4*(x+y-1)^2)");
	y.Modify("0.7*sin(2*pi*x) + 0.5*cos(3*pi*x) + 0.2*sin(pi*x)",0);
	y.Modify("sin(2*pi*x)",1);	y.Modify("cos(2*pi*x)",2);
	y1.Modify("0.5+0.3*cos(2*pi*x)");
	y2.Modify("0.3*sin(2*pi*x)");
	x.Fill(-1,1,'x');
	x2.Modify("0.05+0.03*cos(2*pi*x)");

	gr->SubPlot(1,1,0);
	gr->Rotate(40,60);	gr->Alpha(false);
	gr->Clf();	gr->Box();	gr->Surf(a,"BbcyrR");	gr->WriteSVG("surf.svg");
	gr->Clf();	gr->Box();	gr->Tile(a,"BbcyrR");	gr->WriteSVG("tile.svg");
	gr->Clf();	gr->Box();	gr->Belt(a,"BbcyrR");	gr->WriteSVG("belt.svg");
	gr->Clf();	gr->Box();	gr->Mesh(a,"BbcyrR");	gr->WriteSVG("mesh.svg");
	gr->Clf();	gr->Box();	gr->Fall(a,"BbcyrR");	gr->WriteSVG("fall.svg");
	gr->Clf();	gr->Box();	gr->SurfC(a,b,"BbcyrR");gr->WriteSVG("surfc.svg");
	gr->Clf();	gr->Box();	gr->Boxs(a,"BbcyrR");	gr->WriteSVG("boxs.svg");
	gr->Clf();	gr->Box();	gr->Flow(ex,ey,ez,"bwr");	gr->WriteSVG("flow3.svg");
	gr->Clf();	gr->Box();	gr->Vect(ex,ey,ez,"bwr");	gr->WriteSVG("vect3.svg");
	gr->Clf();	gr->Box();	gr->VectC(ex,ey,ez,"bwr");	gr->WriteSVG("vectc3.svg");
	gr->Clf();	gr->Box();	gr->Torus(y1,y2,"r");	gr->WriteSVG("torus.svg");
	gr->Clf();	gr->Box();	gr->Crust(pnts);		gr->WriteSVG("crust.svg");
	gr->Clf();	gr->Box();	gr->Dots(pnts);			gr->WriteSVG("dots.svg");
	gr->Clf();	gr->Box();	gr->ContF(a,"BbcyrR");	gr->WriteSVG("contf.svg");
	gr->Clf();	gr->Box();	gr->ContFA(c,"BbcyrR");	gr->WriteSVG("contf3.svg");
	gr->Clf();	gr->Box();	gr->Tube(y,0.05);	gr->Tube(y1,x,y2,x2);	gr->WriteSVG("tube.svg");

	gr->Alpha(true);
	gr->Clf();	gr->Box();	gr->Surf(a,"BbcyrR");	gr->WriteSVG("alpha.svg");
	gr->Clf();	gr->Box();	gr->Axial(a,"BbcyrRx");	gr->WriteSVG("axial.svg");
	gr->Clf();	gr->Box();	gr->SurfA(a,b,"BbcyrR");gr->WriteSVG("surfa.svg");
	gr->Clf();	gr->Box();	gr->Map(a,b,"BbcyrR");	gr->WriteSVG("map.svg");
	gr->Clf();	gr->Box();	gr->Surf3(c,"BbcyrR");	gr->WriteSVG("surf3.svg");
	gr->Clf();	gr->Box();	gr->Surf3(c,"bgrd");	gr->WriteSVG("surf3_rgbd_light.svg");
	gr->Clf();	gr->Box();	gr->Surf3A(c,d,"BbcyrR");gr->WriteSVG("surf3a.svg");
	gr->Clf();	gr->Box();	gr->Surf3C(c,d,"BbcyrR");gr->WriteSVG("surf3c.svg");
	gr->Clf();	gr->Box();	gr->ContA(c,"BbcyrR");	gr->WriteSVG("conta.svg");
	gr->Light(false);
	gr->Clf();	gr->Box();	gr->CloudQ(c,"wyrRk");	gr->WriteSVG("cloudq.svg");
	gr->Clf();	gr->Box();	gr->CloudP(c,"wyrRk");	gr->WriteSVG("cloudp.svg");
	gr->Clf();	gr->Box();	gr->Axis();	gr->DensA(c,"BbcyrR");	gr->WriteSVG("densa.svg");
	gr->Alpha(false);
	gr->Clf();	gr->Box();	gr->Surf3(c,"bgrd");gr->WriteSVG("surf3_rgbd.svg");
	gr->Clf();	gr->Box();	gr->DensX(c.Sum("x"),"BbcyrR",-1);	gr->DensY(c.Sum("y"),"BbcyrR",1);
	gr->DensZ(c.Sum("z"),"BbcyrR",-1);	gr->WriteSVG("dens_xyz.svg");
	gr->Clf();	gr->Box();	gr->ContX(c.Sum("x"),"BbcyrR",-1);	gr->ContY(c.Sum("y"),"BbcyrR",1);
	gr->ContZ(c.Sum("z"),"BbcyrR",-1);	gr->WriteSVG("cont_xyz.svg");
	gr->SubPlot(1,1,0);	// 1D Plots
	gr->Clf();	gr->Box();	gr->Plot(y);	gr->WriteSVG("plot.svg");
	gr->Clf();	gr->Box();	gr->Area(y);	gr->WriteSVG("area.svg");
	gr->Clf();	gr->Box();	gr->Stem(y);	gr->WriteSVG("stem.svg");
	gr->Clf();	gr->Box();	gr->Step(y);	gr->WriteSVG("step.svg");
	gr->Clf();	gr->Box();	gr->Bars(y);	gr->WriteSVG("bars.svg");
	gr->Clf();	gr->Box();	gr->Mark(y,y1,"bo");	gr->WriteSVG("mark.svg");
	gr->Clf();	gr->Box();	gr->Plot(y.SubData(-1,0));	gr->Text(y,"This is very long string drawn along a curve",":k");	gr->WriteSVG("text.svg");

	gr->Clf();	gr->Box();	gr->Dens(a,"BbcyrR");	gr->Colorbar();	gr->WriteSVG("dens.svg");
	gr->Clf();	gr->Box();	gr->Cont(a,"BbcyrR");	gr->WriteSVG("cont.svg");
	gr->Clf();	gr->Box();	gr->Vect(a,b,"BbcyrR");	gr->WriteSVG("vect.svg");
	gr->Clf();	gr->Box();	gr->VectC(a,b,"BbcyrR");gr->WriteSVG("vectc.svg");
	gr->Clf();	gr->Box();	gr->Flow(a,b,"BbcyrR");	gr->WriteSVG("flow.svg");

	f.Modify("sin(2*pi*x*x)",0);	f.Modify("sin(2*pi*x)",1);	f.Modify("sin(2*pi*sqrt(x))",2);
	gr->Axis(mglPoint(0,-1,0),mglPoint(1,1,1));	gr->Clf();	gr->Box();
	gr->Plot(f);	gr->Axis("xy");	gr->AddLegend("sin(\\pi {x^2})","b");
	gr->AddLegend("sin(\\pi x)","g*");	gr->AddLegend("sin(\\pi \\sqrt{\\a x})","r+");
	gr->Legend();	gr->WriteSVG("legend.svg");
	gr->ClearLegend();	// clear legend strings
	return 0;
}
//-----------------------------------------------------------------------------
int sample_crust(mglGraph *gr, const void *)
{
	mglData pnts("hotdogs.pts");
	pnts.Norm(-1,1,true);

	gr->Rotate(20,60);
	gr->Light(true);
	gr->Alpha(true);
	gr->Box();
	gr->Crust(pnts);
	//gr->Dots(pnts,"k");
	return 0;
}
//-----------------------------------------------------------------------------
int sample_transp(mglGraph *gr, const void *)	// flag #
{
	gr->Alpha(true);	gr->Light(true);	gr->Light(0,mglPoint(0,0,1));
	mglData a(30,20);
	a.Modify("0.6*sin(2*pi*x)*sin(3*pi*y) + 0.4*cos(3*pi*(x*y))");

	gr->SetScheme("BbcyrR");
	gr->TranspType = 0;	gr->Clf();
	gr->SubPlot(2,2,0);	gr->Rotate(40,60);	gr->Surf(a);	gr->Box();
	gr->SubPlot(2,2,1);	gr->Rotate(40,60);	gr->Dens(a);	gr->Box();
	gr->SubPlot(2,2,2);	gr->Rotate(40,60);	gr->Cont(a);	gr->Box();
	gr->SubPlot(2,2,3);	gr->Rotate(40,60);	gr->Axial(a);	gr->Box();
	gr->WritePNG("type0.png",0,false);

	gr->TranspType = 1;	gr->Clf();
	gr->SubPlot(2,2,0);	gr->Rotate(40,60);	gr->Surf(a);	gr->Box();
	gr->SubPlot(2,2,1);	gr->Rotate(40,60);	gr->Dens(a);	gr->Box();
	gr->SubPlot(2,2,2);	gr->Rotate(40,60);	gr->Cont(a);	gr->Box();
	gr->SubPlot(2,2,3);	gr->Rotate(40,60);	gr->Axial(a);	gr->Box();
	gr->WritePNG("type1.png",0,false);

	gr->TranspType = 2;	gr->Clf();
	gr->SubPlot(2,2,0);	gr->Rotate(40,60);	gr->Surf(a);	gr->Box();
	gr->SubPlot(2,2,1);	gr->Rotate(40,60);	gr->Dens(a);	gr->Box();
	gr->SubPlot(2,2,2);	gr->Rotate(40,60);	gr->Cont(a);	gr->Box();
	gr->SubPlot(2,2,3);	gr->Rotate(40,60);	gr->Axial(a);	gr->Box();
	gr->WritePNG("type2.png",0,false);
	gr->TranspType = 0;	gr->Clf();
	return 0;
}
//-----------------------------------------------------------------------------
int sample_hint(mglGraph *gr, const void *)
{
	mglData  a(50,40), b(50,40), d(50,40), c(61,51,40), y(50,3), y1(50), y2(50);
	a.Modify("0.6*sin(2*pi*x)*sin(3*pi*y) + 0.4*cos(3*pi*(x*y))");
	b.Modify("0.6*cos(2*pi*x)*cos(3*pi*y) + 0.4*cos(3*pi*(x*y))");
	c.Modify("(-2*((2*x-1)^2 + (2*y-1)^2 + (2*z-1)^4 - (2*z-1)^2 - 0.1))");
	y.Modify("0.7*sin(2*pi*x) + 0.5*cos(3*pi*x) + 0.2*sin(pi*x)",0);
	y.Modify("sin(2*pi*x)",1);	y.Modify("cos(2*pi*x)",2);
	y1.Modify("0.3*sin(2*pi*x)");	y2.Modify("0.5+0.3*cos(2*pi*x)");
	for(int i=0;i<a.nx*a.ny;i++)	d.a[i] = hypot(a.a[i],b.a[i]);

	gr->SubPlot(1,1,0);	gr->Clf();	gr->Alpha(false);	gr->Light(false);
	// 2-axis plot
	gr->Clf();	gr->Axis(mglPoint(-1,-1,-1),mglPoint(1,1,1),mglPoint(-1,-1,-1));
	gr->Axis();		gr->Label('y',"axis 1",0);	gr->Plot(y1,"b");
	gr->Axis(mglPoint(0,0,0),mglPoint(1,1,1),mglPoint(1,1,1));	// set up second axis
	gr->Axis();		gr->Label('y',"axis 2",0);	gr->Stem(y2,"r");
	gr->WritePNG("2_axis.png",0,false);
	gr->Axis(mglPoint(-1,-1,-1),mglPoint(1,1,1));
	// contours under mesh
	gr->Clf();	gr->Flow(a,b,"br");	gr->Dens(d,"BbcyrR");	gr->Box();
	gr->WritePNG("flow_dens.png",0,false);

	gr->Rotate(40,60);
	// contours on the surface
	gr->Clf();		gr->Surf(a,"kw");	gr->CAxis(-1,0);	gr->Cont(a,"w");
	gr->CAxis(0,1);	gr->Cont(a,"k");	gr->CAxis(-1,1);	gr->Box();
	gr->WritePNG("surf_cont.png",0,false);

	gr->Light(true);
	// contours under mesh
	gr->Clf();	gr->Mesh(a,"BbcyrR");	gr->Cont(a, 0, 7, -1);	gr->Box();
	gr->WritePNG("mesh_cont.png",0,false);
	// contours on the surface
	gr->Clf();	gr->Surf(a,"BbcyrR");	gr->Cont(a,"y");	gr->Box();
	gr->WritePNG("surf_cont_y.png",0,false);
	// caxis and the surface
	gr->Clf();	gr->CAxis(0,1);	gr->Surf(a,"BbcyrR");	gr->Box();	gr->CAxis(-1,1);
	gr->WritePNG("surf_caxis.png",0,false);
	// caxis and the surface
	gr->Clf();	gr->Axis(mglPoint(-1,-1,0),mglPoint(1,1,1));	gr->Cut=false;
	gr->Surf(a,"BbcyrR");	gr->Box();	gr->Axis(mglPoint(-1,-1,-1),mglPoint(1,1,1));
	gr->WritePNG("surf_cut.png",0,false);
	// several light sources
	gr->Light(1,mglPoint(0,1,0),'c');	gr->Light(2,mglPoint(1,0,0),'y');
	gr->Light(3,mglPoint(0,-1,0),'m');	gr->Clf();	gr->Box();
	gr->Surf(a,"h");	gr->Light(1,false);	gr->Light(2,false);	gr->Light(3,false);
	gr->WritePNG("several_light.png",0,false);

	// CutMin CutMax example
	gr->CutMin = mglPoint(0,-1,-1);	gr->CutMax = mglPoint(1,0,1.1);
	gr->Clf();	gr->Box();	gr->Surf3(-0.5,c,"BbcyrR");
	mglData v(10);	v.Fill(-0.5,1);
	gr->ContF3(v,c,'x',-1,"BbcyrR");	gr->ContF3(v,c,'y',-1,"BbcyrR");
	gr->ContF3(v,c,'z',0,"BbcyrR");		gr->ContF3(v,c,'z',39,"BbcyrR");
	gr->WritePNG("cutminmax2.png",0,false);

	gr->Clf();	gr->Box();	gr->Alpha(true);	gr->Surf3(c,"BbcyrR");
	gr->WritePNG("cutminmax.png",0,false);
	gr->CutMax = gr->CutMin;	// switch off cutting area

	return 0;
}
//-----------------------------------------------------------------------------
int all_samples(mglGraph *gr, const void*)
{
	gr->SubPlot(1,1,0);gr->Clf();sample_a1(gr,0);gr->WritePNG("sample1.png",0,false);
	gr->SubPlot(1,1,0);gr->Clf();sample_a2(gr,0);gr->WritePNG("sample2.png",0,false);
	gr->SubPlot(1,1,0);gr->Clf();sample_a3(gr,0);gr->WritePNG("sample3.png",0,false);
	gr->SubPlot(1,1,0);gr->Clf();sample_a4(gr,0);gr->WritePNG("sample4.png",0,false);
	gr->SubPlot(1,1,0);gr->Clf();sample_a5(gr,0);gr->WritePNG("sample5.png",0,false);
	gr->SubPlot(1,1,0);gr->Clf();sample_a6(gr,0);gr->WritePNG("sample6.png",0,false);
	gr->Axis(mglPoint(-1,-1,-1),mglPoint(1,1,1));
	gr->SubPlot(1,1,0);gr->Clf();sample_a7(gr,0);gr->WritePNG("sample7.png",0,false);
	gr->SubPlot(1,1,0);gr->Clf();sample_a8(gr,0);gr->WritePNG("sample8.png",0,false);
	gr->SubPlot(1,1,0);gr->Clf();sample_a9(gr,0);gr->WritePNG("sample9.png",0,false);
	gr->SubPlot(1,1,0);gr->Clf();sample_aa(gr,0);gr->WritePNG("samplea.png",0,false);
	gr->SubPlot(1,1,0);gr->Clf();sample_ac(gr,0);gr->WritePNG("sampleb.png",0,false);
	gr->SubPlot(1,1,0);gr->Clf();sample_ab(gr,0);gr->WritePNG("samplec.png",0,false);
	gr->SubPlot(1,1,0);gr->Clf();sample_ad(gr,0);gr->WritePNG("sampled.png",0,false);
	gr->CAxis(-1,1);
	return 0;
}
//-----------------------------------------------------------------------------
int sample(mglGraph *gr, const void*)
{
	mglData  a(50,40);
	a.Modify("0.6*sin(2*pi*x)*sin(3*pi*y) + 0.4*cos(3*pi*(x*y))");

	gr->SubPlot(3,3,0);
	gr->Rotate(65,350*0+365*0+380*1+15);	gr->Alpha(true);	gr->AlphaDef = 0.7;
	gr->Light(true);
	gr->Surf(a);
	gr->Box();
	gr->Colorbar();
	return 0;
}

int main(int argc,char **argv)
{
	mglGraphZB zb;
	mglGraphPS ps;

//	sample(&zb,0);	zb.WritePNG("sample.png");

	all_samples(&zb,0);
	sample_transp(&zb,0);
	sample_hint(&zb,0);
	full_test_png(&zb,0);
//	full_test_eps(&ps,0);
//	full_test_svg(&ps,0);
//	mglGraphGLUT gr;	gr.Window(argc,argv,sample1,"MathGL");
//system("pause");
	return 0;
}
//-----------------------------------------------------------------------------
